local frac = FRACUNIT

addHook("PreThinkFrame", function() // for controls
	for p in players.iterate do
		if not (p and p.mo and p.mo.valid) return end
		
		// buttons
		if p.cmd.forwardmove > 0
			p.fbutton = true
		else
			p.fbutton = false
		end
		
		if p.cmd.forwardmove < 0
			p.bbutton = true
		else
			p.bbutton = false
		end
		
		if p.cmd.sidemove > 0
			p.rbutton = true
		else
			p.rbutton = false
		end
		
		if p.cmd.sidemove < 0
			p.lbutton = true
		else
			p.lbutton = false
		end
		
		// button press
		if not p.fbutton then
			p.fbready = true
			p.fb = false
		elseif p.fbready then
			p.fb = true
			p.fbready = false
		else
			p.fb = false
		end
		
		if not p.bbutton then
			p.bbready = true
			p.bb = false
		elseif p.bbready then
			p.bb = true
			p.bbready = false
		else
			p.bb = false
		end
		
		if not p.rbutton then
			p.rbready = true
			p.rb = false
		elseif p.rbready then
			p.rb = true
			p.rbready = false
		else
			p.rb = false
		end
		
		if not p.lbutton then
			p.lbready = true
			p.lb = false
		elseif p.lbready then
			p.lb = true
			p.lbready = false
		else
			p.lb = false
		end
		
		if not (p.cmd.buttons & BT_JUMP) then
			p.jumpready = true
			p.jump = false
		elseif p.jumpready then
			p.jump = true
			p.jumpready = false
		else
			p.jump = false
		end
		
		if not (p.cmd.buttons & BT_USE) then
			p.spinready = true
			p.spin = false
		elseif p.spinready then
			p.spin = true
			p.spinready = false
		else
			p.spin = false
		end
	end
end)

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p and p.mo and p.mo.valid) return end
		
		if p.advmenu.menuopen
			p.advmenu.skincount = #skins - 1
			
			local skincount = p.advmenu.skincount
			local nextskin = p.advmenu.curSel.side + 1
			local nextskin2 = p.advmenu.curSel.side2 + 1
			local prevskin = p.advmenu.curSel.side - 1
			local prevskin2 = p.advmenu.curSel.side2 - 1
			
			if p.rb
				S_StartSound(p.mo, sfx_menu1)
				
				if p.advmenu.advancement == 0
					p.advmenu.curSel.side = $ + 1
				else
					p.advmenu.curSel.side2 = $ + 1
				end
			end
			
			if p.lb
				S_StartSound(p.mo, sfx_menu1)
				
				if p.advmenu.advancement == 0
					p.advmenu.curSel.side = $ - 1
				else
					p.advmenu.curSel.side2 = $ - 1
				end
			end
			
			if p.jump
				if R_SkinUsable(p, skins[p.advmenu.curSel.side].name)
					if p.advmenu.advancement == 0
						S_StartSound(p.mo, sfx_addfil)
						p.advmenu.advancement = 1
					elseif p.advmenu.advancement == 1
						p.advmenu.advancement = 2
					end
				else
					CONS_Printf(p, "\x85"+"Character is locked!")
					S_StartSound(p.mo, sfx_notadd)
				end
				
				if p.advmenu.advancement == 2
					if R_SkinUsable(p, skins[p.advmenu.curSel.side2].name)
						if skins[p.advmenu.curSel.side2].name ~= skins[p.advmenu.curSel.side].name
							S_StartSound(p.mo, sfx_addfil)
							R_SetPlayerSkin(p, p.advmenu.curChar)
							G_AddPlayer(skins[p.advmenu.curBot].name, skins[p.advmenu.curBot].prefcolor, skins[p.advmenu.curBot].realname, BOT_2PAI)
							p.mo.color = skins[p.advmenu.curChar].prefcolor
							p.advmenu.advancement = 0
							p.advmenu.menuopen = false
						else
							CONS_Printf(p, "\x85"+"Cannot pick the same character!")
							S_StartSound(p.mo, sfx_notadd)
						end
					else
						CONS_Printf(p, "\x85"+"Character is locked!")
						S_StartSound(p.mo, sfx_notadd)
					end
				end
			end
			
			if p.spin
				p.advmenu.menuopen = false
				p.advmenu.advancement = 0
			end
			
			if p.advmenu.curSel.side > skincount
				p.advmenu.curSel.side = 0
			elseif p.advmenu.curSel.side == -2
				p.advmenu.curSel.side = skincount - 1
			elseif p.advmenu.curSel.side < 0
				p.advmenu.curSel.side = skincount
			end
			
			if p.advmenu.curSel.side2 > skincount
				p.advmenu.curSel.side2 = 0
			elseif p.advmenu.curSel.side2 == -2
				p.advmenu.curSel.side2 = skincount - 1
			elseif p.advmenu.curSel.side2 < 0
				p.advmenu.curSel.side2 = skincount
			end
			
			p.advmenu.curChar = p.advmenu.curSel.side
			p.advmenu.curBot = p.advmenu.curSel.side2
			
			if p.advmenu.bar.pos ~= 32
				p.advmenu.bar.pos = $ + 1
			else
				p.advmenu.bar.pos = 0
			end
		end
		
		if p.nightstime and p.advmenu.menuopen
			p.advmenu.menuopen = false
			R_SetPlayerSkin(p, "sonic")
		end
	end
end)

hud.add(function(v, p, c)
	if p.nightstime then return end
	
	local skin = skins[p.advmenu.curChar].name
	local skin2 = skins[p.advmenu.curBot].name
	local skinname = skins[p.advmenu.curChar].realname
	local skinname2 = skins[p.advmenu.curBot].realname
	local color = p.advmenu.bar.color
	local color2 = skins[p.advmenu.curChar].prefcolor
	local barpos = p.advmenu.bar.pos
	
	if p.advmenu.menuopen
		v.draw(barpos * -1, 180, v.cachePatch("BAR1"), V_SNAPTOBOTTOM|V_SNAPTOLEFT, v.getColormap(nil, color))
		v.draw(barpos - 32, 0, v.cachePatch("BAR2"), V_SNAPTOTOP|V_SNAPTOLEFT, v.getColormap(nil, color))
		
		v.drawScaled(0, -5*frac, 2*frac, v.cachePatch("NAMEBAR"), V_SNAPTOTOP|V_SNAPTOLEFT, v.getColormap(nil, color2))
		if p.advmenu.advancement == 0
			v.drawString(160, -2, skinname, 0, "center")
		else
			v.drawString(160, -2, skinname.." & "..skinname2, 0, "center")
		end
	
		if p.advmenu.advancement == 0
			v.draw(p.advmenu.pos.x2 + 35, p.advmenu.pos.y2 - 5, v.getSprite2Patch(skin, SPR2_XTRA, false, 1), V_SNAPTOTOP|V_SNAPTOLEFT|V_FLIP)
		else
			v.draw(p.advmenu.pos.x1, p.advmenu.pos.y1, v.getSprite2Patch(skin2, SPR2_XTRA, false, 1), V_SNAPTOTOP|V_SNAPTORIGHT)
			v.draw(p.advmenu.pos.x2, p.advmenu.pos.y2, v.getSprite2Patch(skin, SPR2_XTRA, false, 1), V_SNAPTOTOP|V_SNAPTOLEFT|V_FLIP)
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if (p and p.mo and p.mo.valid)
		if p.advmenu == nil
			p.advmenu = {}
			p.advmenu.menuopen = false
			p.advmenu.curChar = 0
			p.advmenu.curBot = 1
			p.advmenu.skincount = 0
			
			p.advmenu.pos = {}
			p.advmenu.pos.x1 = 90 // 90
			p.advmenu.pos.x2 = 230 // 230
			p.advmenu.pos.y1 = 40 // 40
			p.advmenu.pos.y2 = 60 // 60
			
			p.advmenu.curSel = {}
			p.advmenu.curSel.side = 0
			p.advmenu.curSel.side2 = 0
			p.advmenu.advancement = 0
			
			p.advmenu.bar = {}
			p.advmenu.bar.pos = 0
			p.advmenu.bar.color = SKINCOLOR_WHITE
		end
	end
end)

